# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    download_dict = {
        "windows-x64": "https://downloads.tryton.org/current/tryton-64bit-last.exe",
        "windows-x86": "https://downloads.tryton.org/current/tryton-32bit-last.exe",
    }

    os_type = control.target_os + "-" + ensure_list(control.architecture)[0]

    download_url = requests.head(download_dict[os_type], proxies=proxies).headers['Location']

    latest_bin = download_url.rsplit("/", 1)[-1]
    version = download_url.split("/")[-2]
    latest_bin = latest_bin.replace("last", version)
    latest_bin_extension = latest_bin.rsplit(".")[-1]

    # Downloading latest binaries
    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))

    #nettoyer les fichiers temporaires
    for f in glob.glob(f'*.{latest_bin_extension}'):
        if f != latest_bin:
            remove_file(f)

    control.set_software_version(version)
    control.save_control_to_wapt()

    return package_updated